
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>详解Python的装饰器 / iVAN</title>

    <meta name="description" content="详解Python的装饰器 Python中的装饰器是你进入Python大门的一道坎,不管你跨不跨过去它都在那里. 为什么需要装饰器 我们假设你的程序实现了say_hello()和say_goodbye()两个函数. def say_hello():      print &quot;hello!&quot;        def say_goodbye():      print &quot;hello!&quot;  # bug here    if __name__ == '__main__':      say_he ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">详解Python的装饰器</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Python中的装饰器是你进入Python大门的一道坎，不管你跨不跨过去它都在那里。</p>
<p><strong>为什么需要装饰器</strong></p>
<p>我们假设你的程序实现了say_hello()和say_goodbye()两个函数。</p>
<pre>
</pre>
<ol>
<li>def say_hello(): </li>
<li>    print "hello!" </li>
<li>     </li>
<li>def say_goodbye(): </li>
<li>    print "hello!"  # bug here </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li>    say_hello() </li>
<li>    say_goodbye()  </li>
</ol>
<p>但是在实际调用中，我们发现程序出错了，上面的代码打印了两个hello。经过调试你发现是say_goodbye()出错了。老板要求调用每个方法前都要记录进入函数的名称，比如这样：</p>
<pre>
</pre>
<ol>
<li>[DEBUG]: Enter say_hello() </li>
<li>Hello! </li>
<li>[DEBUG]: Enter say_goodbye() </li>
<li>Goodbye!  </li>
</ol>
<p>好，小A是个毕业生，他是这样实现的。</p>
<pre>
</pre>
<ol>
<li>def say_hello(): </li>
<li>    print "[DEBUG]: enter say_hello()" </li>
<li>    print "hello!" </li>
<li> </li>
<li>def say_goodbye(): </li>
<li>    print "[DEBUG]: enter say_goodbye()" </li>
<li>    print "hello!" </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li>    say_hello() </li>
<li>    say_goodbye()  </li>
</ol>
<p>很low吧? 嗯是的。小B工作有一段时间了，他告诉小A可以这样写。</p>
<pre>
</pre>
<ol>
<li>def debug(): </li>
<li>    import inspect </li>
<li>    caller_name = inspect.stack()[1][3] </li>
<li>    print "[DEBUG]: enter {}()".format(caller_name)    </li>
<li> </li>
<li>def say_hello(): </li>
<li>    debug() </li>
<li>    print "hello!" </li>
<li> </li>
<li>def say_goodbye(): </li>
<li>    debug() </li>
<li>    print "goodbye!" </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li>    say_hello() </li>
<li>    say_goodbye()  </li>
</ol>
<p>是不是好一点?那当然，但是每个业务函数里都要调用一下debug()函数，是不是很难受?万一老板说say相关的函数不用debug，do相关的才需要呢?</p>
<p>那么装饰器这时候应该登场了。</p>
<p>装饰器本质上是一个Python函数，它可以让其他函数在不需要做任何代码变动的前提下增加额外功能，装饰器的返回值也是一个函数对象。它经常用于有切面需求的场景，比如：插入日志、性能测试、事务处理、缓存、权限校验等场景。装饰器是解决这类问题的绝佳设计，有了装饰器，我们就可以抽离出大量与函数功能本身无关的雷同代码并继续重用。</p>
<p>概括的讲，装饰器的作用就是为已经存在的函数或对象添加额外的功能。</p>
<p><strong>怎么写一个装饰器</strong></p>
<p>在早些时候 (Python Version &lt; 2.4，2004年以前)，为一个函数添加额外功能的写法是这样的。</p>
<pre>
</pre>
<ol>
<li>def debug(func): </li>
<li>    def wrapper(): </li>
<li>        print "[DEBUG]: enter {}()".format(func.__name__) </li>
<li>        return func() </li>
<li>    return wrapper </li>
<li> </li>
<li>def say_hello(): </li>
<li>    print "hello!" </li>
<li> </li>
<li>say_hello = debug(say_hello)  # 添加功能并保持原函数名不变  </li>
</ol>
<p>上面的debug函数其实已经是一个装饰器了，它对原函数做了包装并返回了另外一个函数，额外添加了一些功能。因为这样写实在不太优雅，在后面版本的Python中支持了@语法糖，下面代码等同于早期的写法。</p>
<pre>
</pre>
<ol>
<li>def debug(func): </li>
<li>    def wrapper(): </li>
<li>        print "[DEBUG]: enter {}()".format(func.__name__) </li>
<li>        return func() </li>
<li>    return wrapper </li>
<li> </li>
<li>@debug </li>
<li>def say_hello(): </li>
<li>    print "hello!"  </li>
</ol>
<p>这是最简单的装饰器，但是有一个问题，如果被装饰的函数需要传入参数，那么这个装饰器就坏了。因为返回的函数并不能接受参数，你可以指定装饰器函数wrapper接受和原函数一样的参数，比如：</p>
<pre>
</pre>
<ol>
<li>def debug(func): </li>
<li>    def wrapper(something):  # 指定一毛一样的参数 </li>
<li>        print "[DEBUG]: enter {}()".format(func.__name__) </li>
<li>        return func(something) </li>
<li>    return wrapper  # 返回包装过函数 </li>
<li> </li>
<li>@debug </li>
<li>def say(something): </li>
<li>    print "hello {}!".format(something)  </li>
</ol>
<p>这样你就解决了一个问题，但又多了N个问题。因为函数有千千万，你只管你自己的函数，别人的函数参数是什么样子，鬼知道?还好Python提供了可变参数*args和关键字参数**kwargs，有了这两个参数，装饰器就可以用于任意目标函数了。</p>
<pre>
</pre>
<ol>
<li>def debug(func): </li>
<li>    def wrapper(*args, **kwargs):  # 指定宇宙无敌参数 </li>
<li>        print "[DEBUG]: enter {}()".format(func.__name__) </li>
<li>        print 'Prepare and say...', </li>
<li>        return func(*args, **kwargs) </li>
<li>    return wrapper  # 返回 </li>
<li> </li>
<li>@debug </li>
<li>def say(something): </li>
<li>    print "hello {}!".format(something)  </li>
</ol>
<p>至此，你已完全掌握初级的装饰器写法。</p>
<p><strong>高级一点的装饰器</strong></p>
<p>带参数的装饰器和类装饰器属于进阶的内容。在理解这些装饰器之前，最好对函数的闭包和装饰器的接口约定有一定了解。(参见<a href="http://betacat.online/posts/python-closure/%29" rel="external nofollow noreferrer">http://betacat.online/posts/p...</a></p>
<p><strong>带参数的装饰器</strong></p>
<p>假设我们前文的装饰器需要完成的功能不仅仅是能在进入某个函数后打出log信息，而且还需指定log的级别，那么装饰器就会是这样的。</p>
<pre>
</pre>
<ol>
<li>def logging(level): </li>
<li>    def wrapper(func): </li>
<li>        def inner_wrapper(*args, **kwargs): </li>
<li>            print "[{level}]: enter function {func}()".format( </li>
<li>                level=level, </li>
<li>                func=func.__name__) </li>
<li>            return func(*args, **kwargs) </li>
<li>        return inner_wrapper </li>
<li>    return wrapper </li>
<li> </li>
<li>@logging(level='INFO') </li>
<li>def say(something): </li>
<li>    print "say {}!".format(something) </li>
<li> </li>
<li># 如果没有使用@语法，等同于 </li>
<li># say = logging(level='INFO')(say) </li>
<li> </li>
<li>@logging(level='DEBUG') </li>
<li>def do(something): </li>
<li>    print "do {}...".format(something) </li>
<li> </li>
<li>if __name__ == '__main__': </li>
<li>    say('hello') </li>
<li>    do("my work")  </li>
</ol>
<p>是不是有一些晕?你可以这么理解，当带参数的装饰器被打在某个函数上时，比如@logging(level='DEBUG')，它其实是一个函数，会马上被执行，只要这个它返回的结果是一个装饰器时，那就没问题。细细再体会一下。</p>
<p><strong>基于类实现的装饰器</strong></p>
<p>装饰器函数其实是这样一个接口约束，它必须接受一个callable对象作为参数，然后返回一个callable对象。在Python中一般callable对象都是函数，但也有例外。只要某个对象重载了__call__()方法，那么这个对象就是callable的。</p>
<pre>
</pre>
<ol>
<li>class Test(): </li>
<li>    def __call__(self): </li>
<li>        print 'call me!' </li>
<li> </li>
<li>t = Test() </li>
<li>t()  # call me  </li>
</ol>
<p>像__call__这样前后都带下划线的方法在Python中被称为内置方法，有时候也被称为魔法方法。重载这些魔法方法一般会改变对象的内部行为。上面这个例子就让一个类对象拥有了被调用的行为。</p>
<p>回到装饰器上的概念上来，装饰器要求接受一个callable对象，并返回一个callable对象(不太严谨，详见后文)。那么用类来实现也是也可以的。我们可以让类的构造函数__init__()接受一个函数，然后重载__call__()并返回一个函数，也可以达到装饰器函数的效果。</p>
<pre>
</pre>
<ol>
<li>class logging(object): </li>
<li>    def __init__(self, func): </li>
<li>        self.func = func </li>
<li> </li>
<li>    def __call__(self, *args, **kwargs): </li>
<li>        print "[DEBUG]: enter function {func}()".format( </li>
<li>            func=self.func.__name__) </li>
<li>        return self.func(*args, **kwargs) </li>
<li>@logging </li>
<li>def say(something): </li>
<li>    print "say {}!".format(something)  </li>
</ol>
<p><strong>带参数的类装饰器</strong></p>
<p>如果需要通过类形式实现带参数的装饰器，那么会比前面的例子稍微复杂一点。那么在构造函数里接受的就不是一个函数，而是传入的参数。通过类把这些参数保存起来。然后在重载__call__方法是就需要接受一个函数并返回一个函数。</p>
<pre>
</pre>
<ol>
<li>class logging(object): </li>
<li>    def __init__(self, level='INFO'): </li>
<li>        self.level = level </li>
<li>         </li>
<li>    def __call__(self, func): # 接受函数 </li>
<li>        def wrapper(*args, **kwargs): </li>
<li>            print "[{level}]: enter function {func}()".format( </li>
<li>                level=self.level, </li>
<li>                func=func.__name__) </li>
<li>            func(*args, **kwargs) </li>
<li>        return wrapper  #返回函数 </li>
<li> </li>
<li>@logging(level='INFO') </li>
<li>def say(something): </li>
<li>    print "say {}!".format(something)  </li>
</ol>
<p><strong>内置的装饰器</strong></p>
<p>内置的装饰器和普通的装饰器原理是一样的，只不过返回的不是函数，而是类对象，所以更难理解一些。</p>
<p>@property</p>
<p>在了解这个装饰器前，你需要知道在不使用装饰器怎么写一个属性。</p>
<pre>
</pre>
<ol>
<li>def getx(self): </li>
<li>    return self._x </li>
<li> </li>
<li>def setx(self, value): </li>
<li>    self._x = value </li>
<li>     </li>
<li>def delx(self): </li>
<li>   del self._x </li>
<li> </li>
<li># create a property </li>
<li>x = property(getx, setx, delx, "I am doc for x property") </li>
</ol>
<p>以上就是一个Python属性的标准写法，其实和Java挺像的，但是太罗嗦。有了@语法糖，能达到一样的效果但看起来更简单。</p>
<pre>
</pre>
<ol>
<li>@property </li>
<li>def x(self): ... </li>
<li> </li>
<li># 等同于 </li>
<li> </li>
<li>def x(self): ... </li>
<li>x = property(x)  </li>
</ol>
<p>属性有三个装饰器：setter, getter, deleter<br />
，都是在property()的基础上做了一些封装，因为setter和deleter是property()的第二和第三个参数，不能直接套用@语法。getter装饰器和不带getter的属性装饰器效果是一样的，估计只是为了凑数，本身没有任何存在的意义。经过@property装饰过的函数返回的不再是一个函数，而是一个property对象。</p>
<pre>
</pre>
<ol>
<li>&gt;&gt;&gt; property() </li>
<li>&lt;property object at 0x10ff07940&gt;  </li>
</ol>
<p><strong>@staticmethod，@classmethod</strong></p>
<p>有了@property装饰器的了解，这两个装饰器的原理是差不多的。@staticmethod返回的是一个staticmethod类对象，而@classmethod返回的是一个classmethod类对象。他们都是调用的是各自的__init__()构造函数。</p>
<pre>
</pre>
<ol>
<li>class classmethod(object): </li>
<li>    """ </li>
<li>    classmethod(function) -&gt; method </li>
<li>    """     </li>
<li>    def __init__(self, function): # for @classmethod decorator </li>
<li>        pass </li>
<li>    # ... </li>
<li>class staticmethod(object): </li>
<li>    """ </li>
<li>    staticmethod(function) -&gt; method </li>
<li>    """ </li>
<li>    def __init__(self, function): # for @staticmethod decorator </li>
<li>        pass </li>
<li>    # ...  </li>
</ol>
<p>装饰器的@语法就等同调用了这两个类的构造函数。</p>
<pre>
</pre>
<ol>
<li>class Foo(object): </li>
<li> </li>
<li>    @staticmethod </li>
<li>    def bar(): </li>
<li>        pass </li>
<li>     </li>
<li>    # 等同于 bar = staticmethod(bar)  </li>
</ol>
<p>至此，我们上文提到的装饰器接口定义可以更加明确一些，装饰器必须接受一个callable对象，其实它并不关心你返回什么，可以是另外一个callable对象(大部分情况)，也可以是其他类对象，比如property。</p>
<p><strong>装饰器里的那些坑</strong></p>
<p>装饰器可以让你代码更加优雅，减少重复，但也不全是优点，也会带来一些问题。</p>
<p><strong>位置错误的代码</strong></p>
<p>让我们直接看示例代码。</p>
<pre>
</pre>
<ol>
<li>def html_tags(tag_name): </li>
<li>    print 'begin outer function.' </li>
<li>    def wrapper_(func): </li>
<li>        print "begin of inner wrapper function." </li>
<li>        def wrapper(*args, **kwargs): </li>
<li>            content = func(*args, **kwargs) </li>
<li>            print "&lt;{tag}&gt;{content}&lt;/{tag}&gt;".format(tag=tag_name, content=content) </li>
<li>        print 'end of inner wrapper function.' </li>
<li>        return wrapper </li>
<li>    print 'end of outer function' </li>
<li>    return wrapper_ </li>
<li> </li>
<li>@html_tags('b') </li>
<li>def hello(name='Toby'): </li>
<li>    return 'Hello {}!'.format(name) </li>
<li> </li>
<li>hello() </li>
<li>hello()  </li>
</ol>
<p>在装饰器中我在各个可能的位置都加上了print语句，用于记录被调用的情况。你知道他们最后打印出来的顺序吗?如果你心里没底，那么最好不要在装饰器函数之外添加逻辑功能，否则这个装饰器就不受你控制了。以下是输出结果：</p>
<pre>
</pre>
<ol>
<li>begin outer function. </li>
<li>end of outer function </li>
<li>begin of inner wrapper function. </li>
<li>end of inner wrapper function. </li>
<li>&lt;b&gt;Hello Toby!&lt;/b&gt; </li>
<li>&lt;b&gt;Hello Toby!&lt;/b&gt;  </li>
</ol>
<p><strong>错误的函数签名和文档</strong></p>
<p>装饰器装饰过的函数看上去名字没变，其实已经变了。</p>
<pre>
</pre>
<ol>
<li>def logging(func): </li>
<li>    def wrapper(*args, **kwargs): </li>
<li>        """print log before a function.""" </li>
<li>        print "[DEBUG] {}: enter {}()".format(datetime.now(), func.__name__) </li>
<li>        return func(*args, **kwargs) </li>
<li>    return wrapper </li>
<li> </li>
<li>@logging </li>
<li>def say(something): </li>
<li>    """say something""" </li>
<li>    print "say {}!".format(something) </li>
<li> </li>
<li>print say.__name__  # wrapper  </li>
</ol>
<p>为什么会这样呢?只要你想想装饰器的语法糖@代替的东西就明白了。@等同于这样的写法。</p>
<pre>
</pre>
<ol>
<li>say = logging(say) </li>
</ol>
<p>logging其实返回的函数名字刚好是wrapper，那么上面的这个语句刚好就是把这个结果赋值给say，say的__name__自然也就是wrapper了，不仅仅是name，其他属性也都是来自wrapper，比如doc，source等等。</p>
<p>使用标准库里的functools.wraps，可以基本解决这个问题。</p>
<pre>
</pre>
<ol>
<li>from functools import wraps </li>
<li> </li>
<li>def logging(func): </li>
<li>    @wraps(func) </li>
<li>    def wrapper(*args, **kwargs): </li>
<li>        """print log before a function.""" </li>
<li>        print "[DEBUG] {}: enter {}()".format(datetime.now(), func.__name__) </li>
<li>        return func(*args, **kwargs) </li>
<li>    return wrapper </li>
<li> </li>
<li>@logging </li>
<li>def say(something): </li>
<li>    """say something""" </li>
<li>    print "say {}!".format(something) </li>
<li> </li>
<li>print say.__name__  # say </li>
<li>print say.__doc__ # say something  </li>
</ol>
<p>看上去不错!主要问题解决了，但其实还不太完美。因为函数的签名和源码还是拿不到的。</p>
<pre>
</pre>
<ol>
<li>import inspect </li>
<li>print inspect.getargspec(say)  # failed </li>
<li>print inspect.getsource(say)  # failed  </li>
</ol>
<p>如果要彻底解决这个问题可以借用第三方包，比如wrapt。后文有介绍。</p>
<p><strong>不能装饰@staticmethod 或者 @classmethod</strong></p>
<p>当你想把装饰器用在一个静态方法或者类方法时，不好意思，报错了。</p>
<pre>
</pre>
<ol>
<li>class Car(object): </li>
<li>    def __init__(self, model): </li>
<li>        self.model = model </li>
<li> </li>
<li>    @logging  # 装饰实例方法，OK </li>
<li>    def run(self): </li>
<li>        print "{} is running!".format(self.model) </li>
<li> </li>
<li>    @logging  # 装饰静态方法，Failed </li>
<li>    @staticmethod </li>
<li>    def check_model_for(obj): </li>
<li>        if isinstance(obj, Car): </li>
<li>            print "The model of your car is {}".format(obj.model) </li>
<li>        else: </li>
<li>            print "{} is not a car!".format(obj) </li>
<li> </li>
<li>""" </li>
<li>Traceback (most recent call last): </li>
<li>... </li>
<li>  File "example_4.py", line 10, in logging </li>
<li>    @wraps(func) </li>
<li>  File "C:\Python27\lib\functools.py", line 33, in update_wrapper </li>
<li>    setattr(wrapper, attr, getattr(wrapped, attr)) </li>
<li>AttributeError: 'staticmethod' object has no attribute '__module__' </li>
<li>"""  </li>
</ol>
<p>前面已经解释了@staticmethod这个装饰器，其实它返回的并不是一个callable对象，而是一个staticmethod对象，那么它是不符合装饰器要求的(比如传入一个callable对象)，你自然不能在它之上再加别的装饰器。要解决这个问题很简单，只要把你的装饰器放在@staticmethod之前就好了，因为你的装饰器返回的还是一个正常的函数，然后再加上一个@staticmethod是不会出问题的。</p>
<pre>
</pre>
<ol>
<li>class Car(object): </li>
<li>    def __init__(self, model): </li>
<li>        self.model = model </li>
<li> </li>
<li>    @staticmethod </li>
<li>    @logging  # 在@staticmethod之前装饰，OK </li>
<li>    def check_model_for(obj): </li>
<li>        pass  </li>
</ol>
<p><strong>如何优化你的装饰器</strong></p>
<p>嵌套的装饰函数不太直观，我们可以使用第三方包类改进这样的情况，让装饰器函数可读性更好。</p>
<p><strong>decorator.py</strong></p>
<p>decorator.py 是一个非常简单的装饰器加强包。你可以很直观的先定义包装函数wrapper()，再使用decorate(func,  wrapper)方法就可以完成一个装饰器。</p>
<pre>
</pre>
<ol>
<li>from decorator import decorate </li>
<li> </li>
<li>def wrapper(func, *args, **kwargs): </li>
<li>    """print log before a function.""" </li>
<li>    print "[DEBUG] {}: enter {}()".format(datetime.now(), func.__name__) </li>
<li>    return func(*args, **kwargs) </li>
<li> </li>
<li>def logging(func): </li>
<li>    return decorate(func, wrapper)  # 用wrapper装饰func  </li>
</ol>
<p>你也可以使用它自带的@decorator装饰器来完成你的装饰器。</p>
<pre>
</pre>
<ol>
<li>from decorator import decorator </li>
<li> </li>
<li>@decorator </li>
<li>def logging(func, *args, **kwargs): </li>
<li>    print "[DEBUG] {}: enter {}()".format(datetime.now(), func.__name__) </li>
<li>    return func(*args, **kwargs)  </li>
</ol>
<p>decorator.py实现的装饰器能完整保留原函数的name，doc和args，唯一有问题的就是inspect.getsource(func)返回的还是装饰器的源代码，你需要改成inspect.getsource(func.__wrapped__)。</p>
<p><strong>wrapt</strong></p>
<p>wrapt是一个功能非常完善的包，用于实现各种你想到或者你没想到的装饰器。使用wrapt实现的装饰器你不需要担心之前inspect中遇到的所有问题，因为它都帮你处理了，甚至inspect.getsource(func)也准确无误。</p>
<pre>
</pre>
<ol>
<li>import wrapt </li>
<li> </li>
<li># without argument in decorator </li>
<li>@wrapt.decorator </li>
<li>def logging(wrapped, instance, args, kwargs):  # instance is must </li>
<li>    print "[DEBUG]: enter {}()".format(wrapped.__name__) </li>
<li>    return wrapped(*args, **kwargs) </li>
<li> </li>
<li>@logging </li>
<li>def say(something): pass  </li>
</ol>
<p>使用wrapt你只需要定义一个装饰器函数，但是函数签名是固定的，必须是(wrapped, instance, args,<br />
kwargs)，注意第二个参数instance是必须的，就算你不用它。当装饰器装饰在不同位置时它将得到不同的值，比如装饰在类实例方法时你可以拿到这个类实例。根据instance的值你能够更加灵活的调整你的装饰器。另外，args和kwargs也是固定的，注意前面没有星号。在装饰器内部调用原函数时才带星号。</p>
<p>如果你需要使用wrapt写一个带参数的装饰器，可以这样写。</p>
<pre>
</pre>
<ol>
<li>def logging(level): </li>
<li>    @wrapt.decorator </li>
<li>    def wrapper(wrapped, instance, args, kwargs): </li>
<li>        print "[{}]: enter {}()".format(level, wrapped.__name__) </li>
<li>        return wrapped(*args, **kwargs) </li>
<li>    return wrapper </li>
<li> </li>
<li>@logging(level="INFO") </li>
<li>def do(work): pass  </li>
</ol>
<p>关于wrapt的使用，建议查阅官方文档，在此不在赘述。</p>
<ul>
<li><a href="http://wrapt.readthedocs.io/en/latest/quick-start.html" rel="external nofollow noreferrer">http://wrapt.readthedocs.io/e...</a></li>
</ul>
<p><strong>小结</strong></p>
<p>Python的装饰器和Java的注解(Annotation)并不是同一回事，和C#中的特性(Attribute)也不一样，完全是两个概念。</p>
<p>装饰器的理念是对原函数、对象的加强，相当于重新封装，所以一般装饰器函数都被命名为wrapper()，意义在于包装。函数只有在被调用时才会发挥其作用。比如@logging装饰器可以在函数执行时额外输出日志，@cache装饰过的函数可以缓存计算结果等等。</p>
<p>而注解和特性则是对目标函数或对象添加一些属性，相当于将其分类。这些属性可以通过反射拿到，在程序运行时对不同的特性函数或对象加以干预。比如带有Setup的函数就当成准备步骤执行，或者找到所有带有TestMethod的函数依次执行等等。</p>
<p>至此我所了解的装饰器已经讲完，但是还有一些内容没有提到，比如装饰类的装饰器。有机会再补充。谢谢观看。</p>
<p>作者：cicaday</p>
<p>来源：51CTO</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 19:40:19</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/python/" title="python">python</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>详解Python的装饰器的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRoxVz.html" rel="bookmark">Python的装饰器模式与面向切面编程详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了Python的装饰器模式与面向切面编程详解,概括的讲,装饰器的作用就是为已经存在的对象添加额外的功能,本文详细了装饰器模式的方方面面,然后引出面向切面编程知识,需要的朋友可以参考下 今天来讨论一下装饰器.装饰器是一个很著名的设计模式,经常被用于有切面需求的场景,较为经典的有插入日志.性能测试.事务处理等.装饰器是解决这类问题的绝佳设计,有了装饰器,我们就可以抽离出大量函数中与函数功能本身无关的雷同代码并继续重用.概括的讲,装饰器的作用就是为已经存在的对象添加额外的功能. 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGrK6vp.html" rel="bookmark">详解Python中的装饰器、闭包和functools的教程&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				装饰器(Decorators) 装饰器是这样一种设计模式:如果一个类希望添加其他类的一些功能,而不希望通过继承或是直接修改源代码实现,那么可以使用装饰器模式.简单来说Python中的装饰器就是指某些函数或其他可调用对象,以函数或类作为可选输入参数,然后返回函数或类的形式.通过这个在Python2.6版本中被新加入的特性可以用来实现装饰器设计模式. 顺便提一句,在继续阅读之前,如果你对Python中的闭包(Closure)概念不清楚,请查看本文结尾后的附录,如果没有闭包的相关概念,很难恰当的理解P			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxE6qmp.html" rel="bookmark">详解Python装饰器由浅入深&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				装饰器的功能在很多语言中都有,名字也不尽相同,其实它体现的是一种设计模式,强调的是开放封闭原则,更多的用于后期功能升级而不是编写新的代码.装饰器不光能装饰函数,也能装饰其他的对象,比如类,但通常,我们以装饰函数为例子介绍其用法.要理解在Python中装饰器的原理,需要一步一步来.本文尽量描述得浅显易懂,从最基础的内容讲起. (注:以下使用Python3.5.1环境) 一.Python的函数相关基础 第一,必须强调的是python是从上往下顺序执行的,而且碰到函数的定义代码块是不会立即执行它的,只			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrKjXjp.html" rel="bookmark">python函数装饰器用法实例详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文实例讲述了python函数装饰器用法.分享给大家供大家参考.具体如下: 装饰器经常被用于有切面需求的场景,较为经典的有插入日志.性能测试.事务处理等.装饰器是解决这类问题的绝佳设计, 有了装饰器,我们就可以抽离出大量函数中与函数功能本身无关的雷同代码并继续重用.概括的讲,装饰器的作用就是为已经存在的对象添加额外的功能. ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 #! coding=u			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/XpmY7pe.html" rel="bookmark">详解Python中的type&lpar;&rpar;方法的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了详解Python中的type()方法的使用,是Python入门中的基础知识,需要的朋友可以参考下 type()方法返回传递变量的类型.如果传递变量是字典那么它将返回一个字典类型. 语法 以下是type()方法的语法: ? 1 type(dict) 参数 dict -- 这是字典 返回值 此方法返回传递变量的类型. 例子 下面的例子显示type()方法的使用 ? 1 2 3 4 #!/usr/bin/python   dict = {'Name': 'Zara', 'Age'			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M0PLxDM.html" rel="bookmark">详解Python中的序列化与反序列化的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了详解Python中的序列化与反序列化的使用,针对pickle和cPickle对象进行了探究,需要的朋友可以参考下 学习过marshal模块用于序列化和反序列化,但marshal的功能比较薄弱,只支持部分内置数据类型的序列化/反序列化,对于用户自定义的类型就无能为力,同时marshal不支持自引用(递归引用)的对象的序列化.所以直接使用marshal来序列化/反序列化可能不是很方便.还好,python标准库提供了功能更加强大且更加安全的pickle和cPickle模块. cP			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MRyvY8b.html" rel="bookmark">举例详解Python中smtplib模块处理电子邮件的使用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了举例详解Python中smtplib模块处理电子邮件的使用,是Python入门学习中的基础知识,需要的朋友可以参考下 在基于互联网的应用中,程序经常需要自动地发送电子邮件.如:一个网站的注册系统会在用户注册时发送一封邮件来确认注册;当用户忘记登陆密码的时候,通过邮件来取回密码.smtplib模块是python中smtp(简单邮件传输协议)的客户端实现.我们可以使用smtplib模块,轻松的发送电子邮件.下面的例子用了不到十行代码来发送电子邮件: ? 1 2 3 4 5 6			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwlEWWb.html" rel="bookmark">详解Python中threading模块的几个常用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  这篇文章主要介绍了举例详解Python中threading模块的几个常用方法,threading模块用来创建和操作线程,是Python学习当中的重要知识,需要的朋友可以参考下 threading.Thread Thread 是threading模块中最重要的类之一,可以使用它来创建线程.有两种方式来创建线程:一种是通过继承Thread类,重写它的run方法;另一种是创建一个threading.Thread对象,在它的初始化函数(__init__)中将可调用对象作为参数传入.下面分别举例说明.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlRyKNz.html" rel="bookmark">python类装饰器用法实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  本文实例讲述了python类装饰器用法.分享给大家供大家参考.具体如下: ? 1 2 3 4 5 6 7 8 9 10 11 #!coding=utf-8 registry = {} def register(cls): registry[cls.__clsid__] = cls return cls @register class Foo(object): __clsid__ = '123-456' def bar(self): pass print registry 运行结果如下: {'			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqR9Rp.html" rel="bookmark" class="title">button-android删除动态生成的按钮</a>
					<div>
						问题描述 android删除动态生成的按钮 实现生成一些button,数量取决于用户(用户点击按钮,就会生成一个) 具体代码: RelativeLayout layout = (RelativeLay ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XpmAN1p.html" rel="bookmark" class="title">十分钟学习WEBGLOGIC6&period;1</a>
					<div>
						web WEBLOGIC 6.1 的安装 无状态SessionBean开发 数据源的设置 JMS的使用的简单介绍WEBLOGIC 6.1 的安装所需软件: 一个安装用压缩包和一个破解的文件安装过程:1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/7b29gkz.html" rel="bookmark" class="title">高分辨率下界面布局的解决方案</a>
					<div>
						分辨率|解决 高分辨率下文字字体.图像.界面布局的解决方案 为什么要保证我们的软件产品或应用程序中的文本.图像和字体.布局等问题呢,因为我们用户的终端显示设备通常型号和设置各异,如最近出现的16×9, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/rz4LQqz.html" rel="bookmark" class="title">Photoshop实例教程&colon;暗调橙红色调家人照片</a>
					<div>
						原图素材中人物跟主色比较接近,主体不是很突出.处理的时候可以把人物部分稍微调亮,再把草地及天空的颜色色差拉大.这样空间感就强很多.最后还可以把边角部分压暗,可以更好的突出主体部分.原图 最终效果 [1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpnr00p.html" rel="bookmark" class="title">给你一个SERVLET保治百病</a>
					<div>
						servlet import java.io.*;import javax.servlet.*;import javax.servlet.http.*;import java.util.*; publ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvQ7ab.html" rel="bookmark" class="title">谷歌中国搜索业务再遇挑战 转战移动广告市场</a>
					<div>
						  昨日,Google全球副总裁.中国区总裁刘允,出席Google创想时空活动.新京报记者 周岗峰 摄 新京报讯 (记者刘夏)在中国市场艰难前行多年后,由搜索起家的Google开始转战中国移动(微博) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/OM9ZPRp.html" rel="bookmark" class="title">在 运 行 时 刻 创 建 可 改 变 尺 寸 的 控 件</a>
					<div>
						我 们 可 以 将 许 多 不 同 的 控 件, 例 如 文 本 框 控 件, 添 加 到Visual Basic 的 窗 体 上. 在 设 计 期 间, 可 以 调 整 控 件 的 大 小 和 位  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/1MvgWVp.html" rel="bookmark" class="title">《Essential &period;Net》读书笔记 - Chapter 1</a>
					<div>
						笔记 Chapter 1: 1.         组件技术主要强调的是独立开发和部署程序之间的协定(contract,就是说好怎么做就要怎么做).COM是M$首次尝试将这些约定规范化.COM出现之前, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4wJkqp.html" rel="bookmark" class="title">常用Excel技巧</a>
					<div>
						在网上浏览到一些Excel技巧,在这里整理给读者们看一看,说不定您能用得上. 1.两列数据查找相同值对应的位置 =MATCH(B1,A:A,0) 2.已知公式得结果 定义名称=EVALUATE(She ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1NqAz.html" rel="bookmark" class="title">Linux操作系统上Samba常见问题解答</a>
					<div>
						一.由Linux向windows提供文件/目录及打印机共享. 在Linux服务器上的Samba运行起来以后,Linux就相当于一台文件及打印服务器,向windows和Linux Samba客户提供文件 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7kdmZz.html" rel="bookmark" class="title">CSS的注释部分编程引申</a>
					<div>
						  CSS注释 就像HTML教程中描述的一样,在CSS文档中注释也起到很重要的作用,可以帮助我们记起CSS的含义,加载在HTML文档的位置等. CSS注释的开始使用/*,结束使用*/ CSS注释语法  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPgwQz.html" rel="bookmark" class="title">C&num;实现ComboBox自动匹配字符</a>
					<div>
						 1. 采用CustomSource当做提示集合 将下列代码添加到窗口加载函数中即可.假设unitNameList是获取的想要添加到下拉列表中的字符串列表. AutoCompleteStringCol ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB2r5db.html" rel="bookmark" class="title">PPT封面设计的心得</a>
					<div>
						PPT封面在整个PPT中有着举足轻重的作用,直接体现了PPT的中心内容,一个好的封面能给观众带来好的印象,就像人的脸面一样,长得漂亮的 总是会赢来更多的青睐.关于PPT封面设计,也没有什么具体的方法. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwGXKb.html" rel="bookmark" class="title">win8怎么共享文件？</a>
					<div>
						  1.按键盘上[WIN+E]快捷键,进入我的电脑,然后找到您要共享的文件夹.点击鼠标右键选择[共享]--[高级共享] 2.进入共享属性后选择[高级共享]---勾选[共享此文件夹]---点击[权限]检 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Pxgop.html" rel="bookmark" class="title">简单分析javascript面向对象与原型&lowbar;jquery</a>
					<div>
						本文主要内容参考来自JavaScript高级程序设计,面向对象与原型章节: 1.工厂模式 ECMAScript 可以通过工厂模式来创建对象: //工厂模式 function createObject( ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0QyBJp.html" rel="bookmark" class="title">VB转VB&period;NET问题</a>
					<div>
						问题描述 VB转VB.NET问题我以前学过vb6.0,学的还不错,自己做了一套程序,那是XP年代,现在前后是WIN7,WIN8了,之前做的程序越来越不能兼容了,可数据库不能丢,所以开始学vb.net了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bam9wnb.html" rel="bookmark" class="title">DWR推送到jsp页面调的方法没反应</a>
					<div>
						问题描述 ------web.xml&lt;servlet&gt;&lt;servlet-name&gt;dwr&lt;/servlet-name&gt;&lt;servlet-class&gt;or ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXwvwLM.html" rel="bookmark" class="title">&period;net-chart组件绑定数据（DataBindTable）后无法显示曲线或不能显示所有Series</a>
					<div>
						问题描述 chart组件绑定数据(DataBindTable)后无法显示曲线或不能显示所有Series 我用vs2010编写的一个小工具,在利用vs2010附带的chart生成图表时出现无法解决的疑问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M0R80Az.html" rel="bookmark" class="title">形状上下文matlab 怎么建立匹配图像数据库？</a>
					<div>
						问题描述 形状上下文matlab 怎么建立匹配图像数据库? 形状上下文matlab 怎么建立匹配模型数据库?想要通过形状上下文来识别一系列图像,用形状上下文,可能实现嘛?					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeRAnVb.html" rel="bookmark" class="title">中国经济宏观调控仍需谨慎</a>
					<div>
						国家统计局.中国物流与采购联合会昨日发布的数据显示,8月我国制造业采购经理指数(PMI)为51.7%,比上月提高0.5个百分点,连续3个月回落后首度回升.PMI指数高于50%的强弱分界点,表明经济增速 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boKAgDb.html" rel="bookmark" class="title">PHP学习笔记之二 php入门知识&lowbar;php基础</a>
					<div>
						PHP学习笔记之二 1. 数组 PHP的数组其实是一个关联数组,或者说是哈希表.PHP不需要预先声明数组的大小,可以用直接赋值的方式来创建数组.例如: //最传统,用数字做键,赋值 $state[0] ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bB1Bjaz.html" rel="bookmark" class="title">拟写正确的淘宝标题能够汇集更多的人气</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 我想大多数企业的网络工作人员都有优 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXeRBb.html" rel="bookmark" class="title">vs2008创建数据库实例失败</a>
					<div>
						问题描述 我在用vs2008创建一个web应用程序时在app_data文件夹下添加一个数据库时失败,提示&quot;实例失败&quot; 解决方案 解决方案二:实例名正确么?需要加XXX/sqlexp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWQxmM.html" rel="bookmark" class="title">《SQL入门经典（第5版）》导读</a>
					<div>
						关于作者 SQL入门经典(第5版) 本书的作者们10多年来研究.应用和总结了SQL标准以及这些标准在关系型数据库的应用. Ryan Stephens和Ron Plew是Perpetual Techno ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba6lXwM.html" rel="bookmark" class="title">苹果海尔合作的消息在智能家居界引起轩然大波</a>
					<div>
						最近一段时间,苹果海尔合作的消息在智能家居界引起轩然大波,两大巨头的联手开启了人们对智能家居发展前景的美好想象.据悉,自提出互联网转型战略以来,海尔大动作不断,不仅与阿里.百度等达成战略合作,更与苹果 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDkYylp.html" rel="bookmark" class="title">世界银行宣布韩裔美籍医学专家金墉将出任新行长</a>
					<div>
						韩裔美籍医学专家金墉(Jim Yong Kim) 世界银行16日宣布,韩裔美籍医学专家金墉(Jim Yong Kim)今年7月1日将接替佐利克(6月30日卸任)成为世界银行新任行长,任期五年.世行表示 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2qJ1M.html" rel="bookmark" class="title">ionic js 复选框 与普通的 HTML 复选框到底有没区别&lowbar;javascript技巧</a>
					<div>
						 ionic 复选框 ionic 复选框(checkbox)与普通的 HTML 复选框没什么区别,以下实例演示了 ionic 复选框 ion-checkbox 的应用. &lt;ion-checkbo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8N9Rob.html" rel="bookmark" class="title">设置默认打印机</a>
					<div>
						using System.Management;string PrinterName = &quot;HP LaserJet 6L&quot;;ManagementObjectSearcher que ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWkv4z.html" rel="bookmark" class="title">oracle 插入表数据，如果已存在修改其中一条字段值</a>
					<div>
						问题描述 insert into t_a select * from t_b;我将b表的数据一次性插入到a表 通过名字比较.比如说: a表已存在张三这个人 , 还是继续插入,这时存在2个张三,我需要修 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5eRvz.html" rel="bookmark" class="title">百度糯米开店怎么收费&quest;</a>
					<div>
						1.首先打开百度糯米主页,在我里面点击我要开店.没错,就是箭头所指位置. 2.填写相应的商户信息,点击下方确认提交. 有了百度糯米开店入口,商家入驻就可以一键申请啦. 百度糯米开店怎么收费? 收费是肯 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.039 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
